/*--------------------------------*-H-*---------------------------------*
 * File:        bbsnet.h
 *----------------------------------------------------------------------*
 *
 * All portions of code are copyright by their respective author/s.
 * Copyright (C) Hong-Yi Du <HYD.bbs@bbs.yzu.edu.tw>
 * Copyright (C) crazykid <kids.bbs@bbs.yzu.edu.tw>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *---------------------------------------------------------------------*/

/*************************************************************************
HU]wȽФťʧ
*************************************************************************/

#include "config.h"

#define VER             "2.8"
#define ALL             0                       /* CҦ */
#define MY_BOOK         1                       /* ڪ̷RҦ */

#define	COL		4			/* Ʀh֭ */
#define	ROW		19			/* Ʀh֭ */
#define NAME		17			/* Wץ[@ */
#define	TOTAL		( COL * ROW )		/* @Xӯ */
#define DELIMITER	" \t"			/* wqɦr */
#define	CLS		"\x1b[2J\x1b[1;1f"	/* ansi macro   */
#define	YELLOW_BLUE	"\x1b[1;33;44m"		/* rũ     */
#define RED		"\x1b[1;31m"		/*          */
#define	GREEN		"\x1b[1;32m"		/*          */
#define	YELLOW		"\x1b[1;33m"		/*          */
#define BLUE		"\x1b[1;34m"		/* Ŧ         */
#define MAGENTA		"\x1b[1;35m"		/*        */
#define CYAN		"\x1b[1;36m"		/* HŦ       */
#define WHITE		"\x1b[1;37m"		/* զ         */
#define	NORMAL		"\x1b[m"		/* ٭         */
#define	_KEY_UP		65
#define	_KEY_DOWN	66
#define	_KEY_RIGHT	67
#define	_KEY_LEFT	68
#define	_KEY_ESC	27
#define	_KEY_ENTER	13
#define	_KEY_TAB	9

#define MAX_MYBOOK      TOTAL * MAX_MYPAGE      /* ڪ̷R */
#define	SSH_PORT	22			/* ssh port	*/

#define GOTOXY( y, x )	printf( "\x1b[%d;%df", x, y )	
#define SPACE		for( w = 0; w < NAME - 1; w ++ ) printf( " " )

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <termios.h>
#include <ctype.h>
#include <sys/wait.h>
#include <ncurses.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#ifdef LOG
#include <utmp.h>
struct tm *tm_buf3;
#endif

#include <sys/mman.h>

unsigned int shm_key = SHM_KEY;
struct shmid_ds shmseg;
int shmid;

char	max_page = 1;		/* ̤j */ 
char	max_use = MAX_USE;	/* ̤jϥΤH */
char	page = 1; 		/* ثeҦb */
char	last_page = 1;		/* eҦҦb */
char	has_error = 0; 		/* O_ error */
char    cursor_x; 		/*  X b */
char    cursor_y; 		/*  Y b */
char    flag = 0;
char    mode = ALL;           	/* ثeҦ */
char    shm_flag = 0;		/* O_wgϥ shm */
char    del_flag = 0;		/* sɬO_ */
char    view_flag = 1;		/* O_[ݯxsu */
char    rank_flag = 0;		/* xO_ƦCL */

char    buf_string[100];	
char    bbs_book[80];	/* sɤɦW */

#ifdef	USE_DN
char	use_dn = 1;
#else
char	use_dn = 0;
#endif

unsigned int current = 1; 	/* Цb@ӯx */
unsigned int counter = 1; 	/* xƶq   */
unsigned int last_current=1;    /* eҦҦbx */
unsigned int w, y, z;
unsigned long myarray_size;	/* ڪ̷RҥΤ array jp */
unsigned long array_size;	/* xҥΤ array jp */
unsigned long rankarray_size; /* ƦCɩҥΤ array jp */
	
time_t now;
int fd;
FILE *fd1,*fd2;
char datafile[80];

struct termios modes, savemodes, tempmodes;
struct stat stat_data;
struct tm *tm_buf1, *tm_buf2;

/* kids: [J num:xs, times:su */
struct data
{
  char name[NAME + 2];
  char domain[32];
  char ip[16];
  char port[6];
  unsigned int num;
  unsigned int times;
}
*array,*shm_array,*my_array,*rank_array;


/* HYD */
void print_screen();
void message();
void cursor( u_short );
void cursor_move( char, char );
void finish();
#ifdef LOG
void write_log();
#endif

/* kids */
void init_bbsnet();		/* l bbsnet */
void init_shm();		/* l shm    */
void show_help();   		/* beUܪp */
void load_data();		/* J */
void add_book();		/* [Jxܦs */
void del_book();		/* qsɧRx */
void save_book();		/* s */
void show_file(char *);		/* ɮפe */
void pressanykey();		/* @~ */
void rank_data();		/* ƦC */
void search(char,char *);	/* jMx */
void edit(char *);		/* s */
char load_from_file(char *,struct data *);
